#line 1 "C:/Users/Ng Yong Han/Documents/pic_projects2012/pic18f-sramtest/pic18f-sramtest.c"







sbit LCD_RS at LATB0_bit;
sbit LCD_EN at LATB1_bit;
sbit LCD_D4 at LATB2_bit;
sbit LCD_D5 at LATB3_bit;
sbit LCD_D6 at LATB4_bit;
sbit LCD_D7 at LATB5_bit;

sbit LCD_RS_Direction at TRISB0_bit;
sbit LCD_EN_Direction at TRISB1_bit;
sbit LCD_D4_Direction at TRISB2_bit;
sbit LCD_D5_Direction at TRISB3_bit;
sbit LCD_D6_Direction at TRISB4_bit;
sbit LCD_D7_Direction at TRISB5_bit;










unsigned char testData[] = {0, 5, 10, 15, 20, 25, 30, 35};

void init() {

 TRISA = 0x00;
 TRISB = 0x00;
 TRISC = 0x00;
 TRISE = 0x00;
 TRISH = 0x00;
 TRISG = 0x00;
 TRISJ = 0x00;
 ADCON1.PCFG0 = 1;
 ADCON1.PCFG1 = 1;
 ADCON1.PCFG2 = 1;
 ADCON1.PCFG3 = 1;
 CCP1CON.CCP1M0 = 0;
 CCP1CON.CCP1M1 = 0;
 CCP1CON.CCP1M2 = 0;
 CCP1CON.CCP1M3 = 0;
 CCP2CON.CCP2M0 = 0;
 CCP2CON.CCP2M1 = 0;
 CCP2CON.CCP2M2 = 0;
 CCP2CON.CCP2M3 = 0;
 PORTA = 0x00;
 PORTE = 0x00;

  LATG.LATG0  = 1;

}

void write62256(unsigned int address, unsigned char inputData) {

  LATJ.LATJ5  = 1;
  LATG.LATG0  = 1;
  LATJ.LATJ4  = 1;

  LATE  = (address & 0x00ff);
  LATC  = (address & 0x7f00) >> 8;
  TRISH  = 0x00;

  LATG.LATG0  = 0;
  LATJ.LATJ4  = 0;
  LATJ.LATJ5  = 0;

 asm nop
  PORTH  = inputData;

  LATJ.LATJ4  = 1;
  LATJ.LATJ5  = 1;
  LATG.LATG0  = 1;

  PORTH  = 0x00;
}

unsigned char read62256(unsigned int address) {

 unsigned char tempData;

  LATJ.LATJ5  = 1;
  LATG.LATG0  = 1;
  LATJ.LATJ4  = 1;

  LATE  = (address & 0x00ff);
  LATC  = (address & 0x7f00) >> 8;
  TRISH  = 0xff;

  LATG.LATG0  = 0;
  LATJ.LATJ4  = 0;

 asm nop
 tempData =  PORTH ;

  LATJ.LATJ4  = 1;
  LATJ.LATJ5  = 1;
  LATG.LATG0  = 1;

 return tempData;

  PORTH  = 0x00;

}

void check62256() {

 unsigned int i = 0;
 unsigned int j = 0;
 unsigned char addrErrorTxt[7];
 unsigned char tempTestData;

 for (i = 0; i < 8; i++)
 write62256(i, testData[i]);

 delay_ms(100);

 for (i = 0; i < 8; i++) {
 tempTestData = read62256(i);
 if (tempTestData != testData[i]) {
 Lcd_Out(2, 1, "SRAM Not Present");
 while (1) {
 PORTA.RA4 ^= 1;
 delay_ms(250);
 }
 }
 }

 tempTestData = 0;

 for (j = 0; j < 32768; j++) {

 for (i = 0; i < 8; i++) {

 write62256(j, 1 << i);

 tempTestData = read62256(j);
 if (tempTestData != (1 << i)) {
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Out(1, 1, "SRAM Error");
 IntToStr(j, addrErrorTxt);
 Lcd_Out(2, 1, addrErrorTxt);
 while (1) {
 PORTA.RA5 ^= 1;
 delay_ms(250);
 }

 }

 }

 }

}

void main() {

 init();
 delay_ms(1);
 Lcd_Init();
 delay_ms(1);
 Lcd_Cmd(_LCD_CLEAR);
 Lcd_Cmd(_LCD_CURSOR_OFF);
 Lcd_Out(1, 1, "Testing SRAM");
 check62256();
 Lcd_Out(2, 1, "SRAM is OK");
 PORTA.RA3 = 1;

 while (1);

}
